#include <gb.h>
#include <string.h>
#include "font.c"

#define FONT_OFFSET 128

static const unsigned char cEMPTY[] = 
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 

void setup_win_font (void)
{
  char *x;
  UBYTE e,c;
  unsigned char t;

  if( _cpu==CGB_TYPE )
  {
    /* text palette 7 */
    set_bkg_palette_entry(7,0,RGB(31,31,31));
    set_bkg_palette_entry(7,1,RGB(31,0,0)); 
    set_bkg_palette_entry(7,2,RGB(0,0,31));
    set_bkg_palette_entry(7,3,RGB(0,0,0));

    set_bkg_palette_entry(0,0,RGB(31,31,31));
    set_bkg_palette_entry(0,1,RGB(31,0,0)); 
    set_bkg_palette_entry(0,2,RGB(0,0,31));
    set_bkg_palette_entry(0,3,RGB(0,31,0));
  }
  set_win_data ((UBYTE)-128,128,font);
  // setup bkg attribs
  x = (char *) 0xFF4F;
  x[0] = 1;
  t=7;

  // set the window to use palette 7
  
  if (_cpu == CGB_TYPE)
  for (e = 0; e<6;e++)
  for (c=0;c<201;c++)
  { 
      set_win_tiles (c,e,1,1,&t);
  }

  x[0]=0;
}

void empty_screen (void)
{
  UBYTE e; 
  char *x ;
  

 
  HIDE_BKG;
  HIDE_SPRITES;

  for (e=0; e<40; e++)
    move_sprite(e,0,0);

  for (e=0; e<20; e++)
  {
    set_bkg_tiles (0,e,20,1,(unsigned char *) &cEMPTY[0]);   
    set_win_tiles (0,e,20,1,(unsigned char *) &cEMPTY[0]);   

    // set palette to 1
    x = (char *) 0xFF4F;
    x[0] = 1;
    set_bkg_tiles (0,e,20,1,(unsigned char *) &cEMPTY[0]);   
    x[0] = 0;

  }

  move_bkg (0,0);
  
  SHOW_BKG;
  SHOW_SPRITES;
}

/* puts a line of 20 chars onto the window or bkg 
   str = string to print
   starty = line to start printing on
   wb = win or bkg (1 = win, 0 = bkg)
*/

void putln (char str[], UBYTE y, UBYTE wb)
{
  UBYTE c,strx;

  for (strx = 0 ;(str[strx]!=0) && (strx<20);strx++)
  {
    c = str[strx]+FONT_OFFSET;
    if (wb == 1)
      set_win_tiles (strx,y,1,1,(unsigned char *) &c);
    else
      set_bkg_tiles (strx,y,1,1,(unsigned char *) &c);
  }
}

/* Prints a string of text to the background or window
   automatically wordwraps

   str = string to print
   starty = line to start printing on
   wb = win or bkg (1 = win, 0 = bkg)
*/
void println(char str[], UBYTE starty, UBYTE wb)
{
  UBYTE posx,strx,nextlen;
  UBYTE posy,e;
  UBYTE c;
 
  strx=0;
  posx=1;
  posy=starty;
 
  while (str[strx]!=0)
  {
    nextlen = 0;
    for (e=strx;(str[e]!=' ')&&(str[e]!=0);e++)
      nextlen++;

    if (posx+nextlen > 18)
    {
      posx=1;
      posy++;
    }

    if (posx != 1)
    {
      c = ' '+FONT_OFFSET;
      if (wb == 1)
        set_win_tiles (posx,posy,1,1,(unsigned char *) &c);
      else
        set_bkg_tiles (posx,posy,1,1,(unsigned char *) &c);
      posx++;
    }   
  
    for (;(str[strx]!=' ')&&(str[strx]!=0);strx++)
    {
      c = str[strx] + FONT_OFFSET;
      if (wb == 1)
        set_win_tiles (posx,posy,1,1,(unsigned char *) &c);
      else
        set_bkg_tiles (posx,posy,1,1,(unsigned char *) &c);
      posx++;
    }   

    if (str[strx]!=0)
      strx++;   
  }
}

/* Reverse a string */
void reverse(char s[])
{
  int c,i,j;

  for (i=0 , j=strlen(s)-1; i < j; i++,j--){
    c =  s[i];
    s[i] = s[j];
    s[j] = c;
  }
}

/* convert an integer to a string */
void itoa(int n,char a[])
{
  int i, sign;
  
  if ((sign = n) <0)
    n = -n;
  i = 0;
  do {
    a[i++] = n%10+'0';
  } while ((n /= 10) > 0);
  if (sign < 0)
    a[i++] = '\0';
  reverse(a);
}

void main (void)
{
  char y[20];

  setup_win_font ();

  SHOW_WIN; 
  move_win (7,104);

  itoa(54,y);

  println(y,0,1);
  println("TheBorg will get you",1,1);
  putln ("I ate a plane",4,0);
  while (1==1)
    wait_vbl_done();
}

